stages:
  - build
  - deploy

build:docker:
  interruptible: true
  stage: build
  image:
    name: registry.gitlab.com/goopil/kube-agent-config/kaniko:latest
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - |
      /kaniko/executor \
        --cache=true \
        --cache-repo  $CI_REGISTRY_IMAGE/cache \
        --context     . \
        --dockerfile  dockerfile \
        --destination $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:latest

  after_script:
    - rm -Rf /kaniko/.docker

.common_cd:
  variables:
    APP_NAME: nuxt
    BASE_HOST: kd.zvolpi.dev
  image:
    name: registry.gitlab.com/goopil/kube-agent-config/kubectl:latest
    entrypoint: [ "" ]
  before_script:
    - echo "$CI_MERGE_REQUEST_IID"
    - echo "$CI_MERGE_REQUEST_ID"
    - echo "$CI_COMMIT_REF_SLUG"
    - export HOST_PREFIX=$([ "$CI_COMMIT_REF_SLUG" == "master" ] && echo "" || echo "-mr-$CI_MERGE_REQUEST_IID")
    - echo $HOST_PREFIX
    - export ENVIRONMENT_NAME=$APP_NAME$HOST_PREFIX
    - envsubst < kube.manifest.tmpl.yaml > manifest.yaml
    - cat manifest.yaml
    - kubectl config use-context goopil/kube-agent-config:kp

deploy:
  extends: .common_cd
  stage: deploy
  script:
    - kubectl apply -f manifest.yaml
    - kubectl rollout restart deployment/$ENVIRONMENT_NAME
  environment:
    name: $CI_COMMIT_REF_SLUG
    url: "https://$HOST"
    on_stop: teardown

teardown:
  extends: .common_cd
  stage: .post
  script:
    - kubectl delete -f manifest.yaml
  when: manual
  environment:
    name: $CI_COMMIT_REF_SLUG
    action: stop
